#include <jni.h>
#include <stdio.h>
#include <termios.h>
#include <unistd.h>

#include "fi_jyu_mit_ohj2_Readkey.h"

JNIEXPORT jchar JNICALL Java_fi_jyu_mit_ohj2_Readkey_getCharNative
  (JNIEnv * env, jclass class)
{
  char merkki;
  struct termios my_termios, old;
  
  tcgetattr(STDIN_FILENO, &my_termios);
  old = my_termios;     
  my_termios.c_lflag &= ~(ECHO | ICANON);
  my_termios.c_cc[VMIN]  = 1;
  my_termios.c_cc[VTIME] = 0;
  tcsetattr(STDIN_FILENO, TCSAFLUSH, &my_termios);
  
  merkki = getchar();     
  
  tcsetattr(STDIN_FILENO, TCSAFLUSH, &old);
  return merkki;
}
